package nc.fp.ws.bill;

package ..deTemp.1736863652506;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.impl.pubapp.pattern.data.bill.BillQuery;
import nc.itf.scmpub.reference.uap.pf.PfServiceScmUtil;
import nc.itf.so.m32.ISaleInvoiceMaintain;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.pf.IPFBusiAction;
import nc.jdbc.framework.processor.ArrayListProcessor;
import nc.jdbc.framework.processor.ResultSetProcessor;
import nc.vo.ic.m4c.entity.SaleOutBodyVO;
import nc.vo.ic.m4c.entity.SaleOutVO;
import nc.vo.pub.AggregatedValueObject;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pubapp.pattern.model.entity.bill.IBill;
import nc.vo.so.m30.entity.SaleOrderVO;
import nc.vo.so.m32.entity.SaleInvoiceBVO;
import nc.vo.so.m32.entity.SaleInvoiceVO;
import nc.vo.so.m32.util.SaleInvoiceVOCalculator;
import nccloud.openapi.scmpub.util.BillFieldsCodeToPkUtil;

public class DealXSFP01bill {
  public String getInfoToCreatBill(String jsonString) throws BusinessException {
    try {
      JSONObject receiveObj = new JSONObject();
      SaleInvoiceVO[] transOutVO = null;
      JSONObject returnObj = new JSONObject();
      receiveObj = JSON.parseObject(jsonString);
      String action = receiveObj.getString("action");
      if (action.toUpperCase().equals("APPROVE")) {
        IPFBusiAction service = (IPFBusiAction)NCLocator.getInstance().lookup(IPFBusiAction.class);
        String type = receiveObj.getString("type");
        String flag = receiveObj.getString("flag");
        if ("1".equals(type)) {
          if ("Y".equals(flag)) {
            transOutVO = dkcfaggvo(receiveObj);
            if (transOutVO == null || transOutVO.length == 0)
              throw new BusinessException("转单失败，请检查"); 
            if (transOutVO.length != 2)
              throw new BusinessException("拆分单据有误，请检查"); 
          } else {
            transOutVO = dkbcaggvo(receiveObj);
            if (transOutVO == null || transOutVO.length == 0)
              throw new BusinessException("转单失败，请检查"); 
            if (transOutVO.length != 1)
              throw new BusinessException("合并单据有误，所选出库不能合并开票，请检查业务单位等信息"); 
          } 
        } else {
          transOutVO = dxbcaggvo(receiveObj);
          if (transOutVO == null || transOutVO.length == 0)
            throw new BusinessException("转单失败，请检查"); 
          if (transOutVO.length != 1)
            throw new BusinessException("合并单据有误，所选出库不能合并开票，请检查业务单位等信息"); 
        } 
        InvocationInfoProxy.getInstance().setProperty("pushflag", "Y");
        for (int i = 0; i < transOutVO.length; i++) {
          SaleInvoiceVOCalculator calculate = new SaleInvoiceVOCalculator(transOutVO[i]);
          transOutVO[i].getParentVO().setStatus(2);
          String matcalss = getStrFsql("select f.name from bd_marbasclass f where f.pk_marbasclass in (select w.pk_marbasclass from bd_material w where pk_material = '" + transOutVO[i].getChildrenVO()[0].getVbdef24() + "')");
          transOutVO[i].getParentVO().setVnote("售" + matcalss);
          for (int j = 0; j < (transOutVO[i].getChildrenVO()).length; j++) {
            transOutVO[i].getChildrenVO()[j].setCrowno(String.valueOf((j + 1) * 10));
            transOutVO[i].getChildrenVO()[j].setStatus(2);
            transOutVO[i].getChildrenVO()[j].setVchangerate("1/1");
            calculate.calculate(j, "nnum");
          } 
        } 
        BillFieldsCodeToPkUtil.doTranslateVOFields((IBill[])transOutVO);
        InvocationInfoProxy.getInstance().setGroupId(transOutVO[0].getParentVO().getPk_group());
        InvocationInfoProxy.getInstance().setUserId(transOutVO[0].getParentVO().getCreator());
        service.processBatch("WRITE", "32", (AggregatedValueObject[])transOutVO, null, null, null);
        returnObj.put("returnFlag", "1");
        returnObj.put("message", "开票成功");
        returnObj.put("data", "[]");
      } 
      if (action.toUpperCase().equals("UPDATE")) {
        ISaleInvoiceMaintain saleInvoiceMaintain = (ISaleInvoiceMaintain)NCLocator.getInstance().lookup(ISaleInvoiceMaintain.class);
        JSONObject billinfo = receiveObj.getJSONArray("billinfo").getJSONObject(0);
        String csaleinvoiceid = billinfo.getJSONObject("headvo").getString("csaleinvoiceid");
        String vnote = billinfo.getJSONObject("headvo").getString("vnote");
        String vdef4 = billinfo.getJSONObject("headvo").getString("vdef4");
        String vdef5 = billinfo.getJSONObject("headvo").getString("vdef5");
        String vbdef26 = billinfo.getJSONObject("headvo").getString("vbdef26");
        String vbdef5 = billinfo.getJSONObject("headvo").getString("vbdef5");
        SaleInvoiceVO[] invo = querydvo(new String[] { csaleinvoiceid });
        invo[0].getParentVO().setVdef4(vnote);
        invo[0].getParentVO().setVdef14(vdef4);
        invo[0].getParentVO().setVdef5(vdef5);
        invo[0].getParentVO().setStatus(1);
        String matcalss = getStrFsql("select f.name from bd_marbasclass f where f.pk_marbasclass in (select w.pk_marbasclass from bd_material w where pk_material = '" + invo[0].getChildrenVO()[0].getVbdef24() + "')");
        invo[0].getParentVO().setVnote("售" + matcalss);
        for (int i = 0; i < (invo[0].getChildrenVO()).length; i++) {
          invo[0].getChildrenVO()[i].setVbdef26(vbdef26);
          invo[0].getChildrenVO()[i].setVbdef5(vbdef5);
          invo[0].getChildrenVO()[i].setStatus(1);
        } 
        InvocationInfoProxy.getInstance().setGroupId(invo[0].getParentVO().getPk_group());
        InvocationInfoProxy.getInstance().setUserId(invo[0].getParentVO().getCreator());
        saleInvoiceMaintain.updateSaleInvoice(invo);
        returnObj.put("returnFlag", "1");
        returnObj.put("message", "开票修改成功");
        returnObj.put("data", "[]");
      } 
      if (action.toUpperCase().equals("DELETE")) {
        ISaleInvoiceMaintain saleInvoiceMaintain = (ISaleInvoiceMaintain)NCLocator.getInstance().lookup(ISaleInvoiceMaintain.class);
        JSONObject billinfo = receiveObj.getJSONArray("billinfo").getJSONObject(0);
        String csaleinvoiceid = billinfo.getJSONObject("headvo").getString("csaleinvoiceid");
        SaleInvoiceVO[] invo = querydvo(new String[] { csaleinvoiceid });
        InvocationInfoProxy.getInstance().setGroupId(invo[0].getParentVO().getPk_group());
        InvocationInfoProxy.getInstance().setUserId(invo[0].getParentVO().getCreator());
        saleInvoiceMaintain.deleteSaleInvoice(invo);
        returnObj.put("returnFlag", "1");
        returnObj.put("message", "撤回（删除）发票成功");
        returnObj.put("data", "[]");
      } 
      return returnObj.toString();
    } catch (Exception e) {
      if (e.getMessage() == null)
        throw new BusinessException("{\"returnFlag\":\"0\",\"message\":\"失败 :开票失败" + e.getMessage() + "\",\"data\":{ }}"); 
      throw new BusinessException("{\"returnFlag\":\"0\",\"message\":\"失败 :开票失败" + e.getMessage().replace("\n", "").replace("\r", "") + "\",\"data\":{ }}");
    } 
  }
  
  public SaleInvoiceVO[] dkcfaggvo(JSONObject billinfo) throws BusinessException {
    JSONObject receiveObj = billinfo.getJSONArray("billinfo").getJSONObject(0);
    JSONArray array = receiveObj.getJSONArray("childvo");
    JSONObject headvo = receiveObj.getJSONObject("headvo");
    SaleInvoiceVO[] transOutVO = new SaleInvoiceVO[array.size()];
    String csourcebill = billinfo.getString("csourcebill");
    if ("4C".equals(csourcebill)) {
      SaleOutVO[] purVO = queryovo(new String[] { headvo.getString("csrcid") });
      InvocationInfoProxy.getInstance().setGroupId(purVO[0].getParentVO().getPk_group());
      InvocationInfoProxy.getInstance().setUserId(purVO[0].getParentVO().getCreator());
      for (int i = 0; i < (purVO[0].getBodys()).length; i++) {
        UFDouble nsignnum = (purVO[0].getBodys()[i].getNsignnum() == null) ? new UFDouble(0) : purVO[0].getBodys()[i].getNsignnum();
        UFDouble naccumwastnum = (purVO[0].getBodys()[i].getNaccumwastnum() == null) ? new UFDouble(0) : purVO[0].getBodys()[i].getNaccumwastnum();
        purVO[0].getBodys()[i].setNinvoicenum(purVO[0].getBodys()[i].getNnum().sub(nsignnum).sub(naccumwastnum));
      } 
      SaleInvoiceVO[] tempvo = (SaleInvoiceVO[])PfServiceScmUtil.exeVOChangeByBizFlow("4C", "32", (AggregatedValueObject[])purVO);
      SaleInvoiceVO[] tempvo01 = (SaleInvoiceVO[])PfServiceScmUtil.exeVOChangeByBizFlow("4C", "32", (AggregatedValueObject[])purVO);
      SaleInvoiceVO[] tempvo02 = (SaleInvoiceVO[])PfServiceScmUtil.exeVOChangeByBizFlow("4C", "32", (AggregatedValueObject[])purVO);
      JSONObject childvo01 = JSONObject.parseObject(array.get(0).toString());
      JSONObject childvo02 = JSONObject.parseObject(array.get(1).toString());
      String nnum01 = childvo01.getString("nnum");
      if ((tempvo[0].getChildrenVO()).length == 1) {
        for (String itemkey : headvo.keySet()) {
          tempvo01[0].getParentVO().setAttributeValue(itemkey, headvo.get(itemkey));
          tempvo02[0].getParentVO().setAttributeValue(itemkey, headvo.get(itemkey));
          if ("ctrantypeid".equals(itemkey)) {
            String ctrantypeid = getStrFsql("select h.pk_billtypeid from bd_billtype h where h.pk_billtypecode = '" + headvo.get(itemkey) + "' and pk_group = (select pk_group from org_group)");
            tempvo01[0].getParentVO().setCtrantypeid(ctrantypeid);
            tempvo01[0].getParentVO().setVtrantypecode(headvo.get(itemkey).toString());
            tempvo02[0].getParentVO().setCtrantypeid(ctrantypeid);
            tempvo02[0].getParentVO().setVtrantypecode(headvo.get(itemkey).toString());
          } 
        } 
        for (String itemkey : childvo01.keySet())
          tempvo01[0].getChildrenVO()[0].setAttributeValue(itemkey, childvo01.get(itemkey)); 
        for (String itemkey : childvo02.keySet())
          tempvo02[0].getChildrenVO()[0].setAttributeValue(itemkey, childvo02.get(itemkey)); 
      } else {
        UFDouble nnumtmp = new UFDouble(nnum01);
        UFDouble bnnumtmp = new UFDouble(0);
        UFDouble nnumtemp = new UFDouble(0);
        int in = 0;
        for (int j = 0; j < (tempvo[0].getChildrenVO()).length; j++) {
          UFDouble bnnum = tempvo01[0].getChildrenVO()[j].getNnum();
          bnnumtmp = bnnumtmp.add(bnnum);
          if (nnumtmp.compareTo(bnnumtmp) < 0) {
            SaleInvoiceBVO[] bvo01 = new SaleInvoiceBVO[j + 1];
            for (int m = 0; m < j + 1; m++) {
              for (String itemkey : childvo01.keySet()) {
                if (!"nnum".equals(itemkey) && !"norigtaxmny".equals(itemkey))
                  tempvo01[0].getChildrenVO()[m].setAttributeValue(itemkey, childvo01.get(itemkey)); 
              } 
              if (m == j) {
                nnumtemp = tempvo01[0].getChildrenVO()[m].getNnum().sub(tempvo01[0].getChildrenVO()[m].getNnum().sub(bnnumtmp.sub(nnumtmp)));
                tempvo01[0].getChildrenVO()[m].setNnum(tempvo01[0].getChildrenVO()[m].getNnum().sub(bnnumtmp.sub(nnumtmp)));
              } 
              bvo01[m] = tempvo01[0].getChildrenVO()[m];
              in++;
            } 
            tempvo01[0].setChildrenVO((CircularlyAccessibleValueObject[])bvo01);
            break;
          } 
        } 
        SaleInvoiceBVO[] bvo02 = new SaleInvoiceBVO[(tempvo[0].getChildrenVO()).length - in + 1];
        for (int k = in - 1; k < (tempvo[0].getChildrenVO()).length; k++) {
          if (k == in - 1)
            tempvo02[0].getChildrenVO()[k].setNnum(nnumtemp); 
          bvo02[k - in + 1] = tempvo02[0].getChildrenVO()[k];
        } 
        tempvo02[0].setChildrenVO((CircularlyAccessibleValueObject[])bvo02);
      } 
      transOutVO[0] = tempvo01[0];
      transOutVO[1] = tempvo02[0];
    } 
    return transOutVO;
  }
  
  public SaleInvoiceVO[] dkbcaggvo(JSONObject billinfo) throws BusinessException {
    JSONObject receiveObj = billinfo.getJSONArray("billinfo").getJSONObject(0);
    JSONArray array = receiveObj.getJSONArray("childvo");
    JSONObject headvo = receiveObj.getJSONObject("headvo");
    SaleInvoiceVO[] tempvo = null;
    String csourcebill = billinfo.getString("csourcebill");
    if ("4C".equals(csourcebill)) {
      SaleOutVO[] purVO = queryovo(new String[] { headvo.getString("csrcid") });
      InvocationInfoProxy.getInstance().setGroupId(purVO[0].getParentVO().getPk_group());
      InvocationInfoProxy.getInstance().setUserId(purVO[0].getParentVO().getCreator());
      int n = 0;
      for (int i = 0; i < (purVO[0].getBodys()).length; i++) {
        if (purVO[0].getBodys()[i].getNnum().compareTo(new UFDouble(0)) > 0)
          n++; 
      } 
      List<SaleOutBodyVO> svo = new ArrayList<>();
      int nn = 0;
      int j;
      for (j = 0; j < (purVO[0].getBodys()).length; j++) {
        if (purVO[0].getBodys()[j].getNnum().compareTo(new UFDouble(0)) > 0) {
          UFDouble nsignnum = (purVO[0].getBodys()[j].getNsignnum() == null) ? new UFDouble(0) : purVO[0].getBodys()[j].getNsignnum();
          UFDouble naccumwastnum = (purVO[0].getBodys()[j].getNaccumwastnum() == null) ? new UFDouble(0) : purVO[0].getBodys()[j].getNaccumwastnum();
          purVO[0].getBodys()[j].setNinvoicenum(purVO[0].getBodys()[j].getNnum().sub(nsignnum).sub(naccumwastnum));
          if (purVO[0].getBodys()[j].getNinvoicenum().compareTo(UFDouble.ZERO_DBL) != 0)
            svo.add(purVO[0].getBodys()[j]); 
          nn++;
        } 
      } 
      purVO[0].setChildrenVO((CircularlyAccessibleValueObject[])svo.toArray((Object[])new SaleOutBodyVO[svo.size()]));
      tempvo = (SaleInvoiceVO[])PfServiceScmUtil.exeVOChangeByBizFlow("4C", "32", (AggregatedValueObject[])purVO);
      for (String itemkey : headvo.keySet()) {
        tempvo[0].getParentVO().setAttributeValue(itemkey, headvo.get(itemkey));
        if ("ctrantypeid".equals(itemkey)) {
          String ctrantypeid = getStrFsql("select h.pk_billtypeid from bd_billtype h where h.pk_billtypecode = '" + headvo.get(itemkey) + "' and pk_group = (select pk_group from org_group)");
          tempvo[0].getParentVO().setCtrantypeid(ctrantypeid);
          tempvo[0].getParentVO().setVtrantypecode(headvo.get(itemkey).toString());
        } 
      } 
      for (j = 0; j < array.size(); j++) {
        JSONObject childvo = array.getJSONObject(j);
        for (String itemkey : childvo.keySet()) {
          if (!"nnum".equals(itemkey))
            tempvo[0].getChildrenVO()[j].setAttributeValue(itemkey, childvo.get(itemkey)); 
        } 
      } 
      UFDouble ntotalastnum = new UFDouble(headvo.getString("ntotalastnum"));
      UFDouble nnum = new UFDouble(0);
      int index = 1;
      for (int k = 0; k < (tempvo[0].getChildrenVO()).length; k++) {
        nnum = nnum.add(tempvo[0].getChildrenVO()[k].getNnum());
        if (nnum.compareTo(ntotalastnum) < 0)
          index++; 
      } 
      if (ntotalastnum.compareTo(nnum) != 0) {
        SaleInvoiceBVO[] bvo = new SaleInvoiceBVO[index];
        UFDouble num = new UFDouble(0);
        for (int m = 0; m < (tempvo[0].getChildrenVO()).length; m++) {
          num = num.add(tempvo[0].getChildrenVO()[m].getNnum());
          if (num.compareTo(ntotalastnum) < 0) {
            bvo[m] = tempvo[0].getChildrenVO()[m];
          } else {
            tempvo[0].getChildrenVO()[m].setNnum(tempvo[0].getChildrenVO()[m].getNnum().sub(num.sub(ntotalastnum)));
            bvo[m] = tempvo[0].getChildrenVO()[m];
          } 
        } 
        tempvo[0].setChildrenVO((CircularlyAccessibleValueObject[])bvo);
      } 
    } else if ("30".equals(csourcebill)) {
      SaleOrderVO[] purVO = querypvo(new String[] { headvo.getString("csrcid") });
      InvocationInfoProxy.getInstance().setGroupId(purVO[0].getParentVO().getPk_group());
      InvocationInfoProxy.getInstance().setUserId(purVO[0].getParentVO().getCreator());
      tempvo = (SaleInvoiceVO[])PfServiceScmUtil.exeVOChangeByBizFlow("30", "32", (AggregatedValueObject[])purVO);
      for (String itemkey : headvo.keySet()) {
        tempvo[0].getParentVO().setAttributeValue(itemkey, headvo.get(itemkey));
        if ("ctrantypeid".equals(itemkey)) {
          String ctrantypeid = getStrFsql("select h.pk_billtypeid from bd_billtype h where h.pk_billtypecode = '" + headvo.get(itemkey) + "' and pk_group = (select pk_group from org_group)");
          tempvo[0].getParentVO().setCtrantypeid(ctrantypeid);
          tempvo[0].getParentVO().setVtrantypecode(headvo.get(itemkey).toString());
        } 
      } 
      for (int i = 0; i < array.size(); i++) {
        JSONObject childvo = array.getJSONObject(i);
        for (String itemkey : childvo.keySet())
          tempvo[0].getChildrenVO()[i].setAttributeValue(itemkey, childvo.get(itemkey)); 
      } 
    } 
    return tempvo;
  }
  
  public SaleInvoiceVO[] dxbcaggvo(JSONObject billinfo) throws BusinessException {
    SaleInvoiceVO[] transOutVO = null;
    JSONArray receiveObj = billinfo.getJSONArray("billinfo");
    List<String> list = new ArrayList();
    for (int i = 0; i < receiveObj.size(); i++) {
      JSONObject jSONObject = receiveObj.getJSONObject(i);
      JSONArray csrcid = jSONObject.getJSONObject("headvo").getJSONArray("csrcid");
      for (int m = 0; m < csrcid.size(); m++)
        list.add(csrcid.getString(m)); 
    } 
    String[] str = new String[list.size()];
    for (int j = 0; j < list.size(); j++)
      str[j] = list.get(j).toString(); 
    String csourcebill = billinfo.getString("csourcebill");
    if ("4C".equals(csourcebill)) {
      SaleOutVO[] purVO = queryovo(removeDuplicates(str));
      InvocationInfoProxy.getInstance().setGroupId(purVO[0].getParentVO().getPk_group());
      InvocationInfoProxy.getInstance().setUserId(purVO[0].getParentVO().getCreator());
      for (int m = 0; m < purVO.length; m++) {
        for (int n = 0; n < (purVO[m].getBodys()).length; n++) {
          UFDouble nsignnum = (purVO[m].getBodys()[n].getNsignnum() == null) ? new UFDouble(0) : purVO[m].getBodys()[n].getNsignnum();
          UFDouble naccumwastnum = (purVO[m].getBodys()[n].getNaccumwastnum() == null) ? new UFDouble(0) : purVO[m].getBodys()[n].getNaccumwastnum();
          purVO[m].getBodys()[n].setNinvoicenum(purVO[m].getBodys()[n].getNnum().sub(nsignnum).sub(naccumwastnum));
        } 
      } 
      transOutVO = (SaleInvoiceVO[])PfServiceScmUtil.exeVOChangeByBizFlow("4C", "32", (AggregatedValueObject[])purVO);
    } 
    JSONObject billinfotmp = receiveObj.getJSONObject(0);
    JSONObject headvo = billinfotmp.getJSONObject("headvo");
    for (int k = 0; k < transOutVO.length; k++) {
      for (String itemkey : headvo.keySet()) {
        if ("ctrantypeid".equals(itemkey)) {
          String ctrantypeid = getStrFsql("select h.pk_billtypeid from bd_billtype h where h.pk_billtypecode = '" + headvo.get(itemkey) + "' and pk_group = (select pk_group from org_group)");
          transOutVO[k].getParentVO().setCtrantypeid(ctrantypeid);
          transOutVO[k].getParentVO().setVtrantypecode(headvo.get(itemkey).toString());
          continue;
        } 
        transOutVO[k].getParentVO().setAttributeValue(itemkey, headvo.get(itemkey));
      } 
      for (int m = 0; m < (transOutVO[k].getChildrenVO()).length; m++) {
        String flag = "N";
        String matcode = getStrFsql("select code from bd_material where pk_material = '" + transOutVO[k].getChildrenVO()[m].getVbdef24() + "'");
        for (int n = 0; n < receiveObj.size() && 
          !"Y".equals(flag); n++) {
          JSONArray childvotmp = receiveObj.getJSONObject(n).getJSONArray("childvo");
          for (int i1 = 0; i1 < childvotmp.size(); i1++) {
            JSONObject cldtmp = childvotmp.getJSONObject(i1);
            String vbdef24 = cldtmp.getString("vbdef24");
            if (matcode.equals(vbdef24)) {
              transOutVO[k].getChildrenVO()[m].setVbdef26(cldtmp.getString("vbdef26"));
              transOutVO[k].getChildrenVO()[m].setVbdef5(cldtmp.getString("vbdef5"));
              flag = "Y";
              break;
            } 
          } 
        } 
      } 
    } 
    return transOutVO;
  }
  
  public static String[] removeDuplicates(String[] array) {
    Set<String> uniqueSet = new HashSet<>();
    byte b;
    int i;
    String[] arrayOfString;
    for (i = (arrayOfString = array).length, b = 0; b < i; ) {
      String item = arrayOfString[b];
      uniqueSet.add(item);
      b++;
    } 
    return uniqueSet.<String>toArray(new String[0]);
  }
  
  public SaleOrderVO[] querypvo(String[] pk) {
    BillQuery<SaleOrderVO> billquery = new BillQuery(SaleOrderVO.class);
    SaleOrderVO[] aggvo = (SaleOrderVO[])billquery.query(pk);
    return aggvo;
  }
  
  public SaleOutVO[] queryovo(String[] pk) {
    BillQuery<SaleOutVO> billquery = new BillQuery(SaleOutVO.class);
    SaleOutVO[] aggvo = (SaleOutVO[])billquery.query(pk);
    for (int i = 0; i < aggvo.length; i++) {
      List<SaleOutBodyVO> newSvo = new ArrayList<>();
      for (int j = 0; j < (aggvo[i].getBodys()).length; j++) {
        if ((new UFDouble(0)).compareTo(aggvo[i].getBodys()[j].getNnum()) != 0)
          newSvo.add(aggvo[i].getBodys()[j]); 
      } 
      aggvo[i].setChildrenVO((CircularlyAccessibleValueObject[])newSvo.toArray((Object[])new SaleOutBodyVO[newSvo.size()]));
    } 
    return aggvo;
  }
  
  public SaleInvoiceVO[] querydvo(String[] pk) {
    BillQuery<SaleInvoiceVO> billquery = new BillQuery(SaleInvoiceVO.class);
    SaleInvoiceVO[] aggvo = (SaleInvoiceVO[])billquery.query(pk);
    return aggvo;
  }
  
  public static String getStrFsql(String strsql) {
    IUAPQueryBS qryBS = (IUAPQueryBS)NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
    try {
      List list = (List)qryBS.executeQuery(strsql, null, (ResultSetProcessor)new ArrayListProcessor());
      if (list != null && list.size() > 0) {
        String s = "";
        if (((Object[])list.get(0))[0] != null)
          s = ((Object[])list.get(0))[0].toString(); 
        return s;
      } 
    } catch (Exception e) {
      e.printStackTrace();
      return null;
    } 
    return null;
  }
}
